Subject: Re: bug#13968: 24.3.50; emacs_backtrace.txt

From: Eli Zaretskii <[email-masked]>
Date: Sat, 16 Mar 2013 09:17:31 +0200

> From: "Drew Adams" <[email-masked]>
> Cc: <[email-masked]>
> Date: Fri, 15 Mar 2013 14:34:09 -0700
> 
> > > Useless without a recipe.
> > 
> > Forgot to show where it aborts:
> > 
> > 	  form.rcArea.bottom = (WINDOW_BOTTOM_EDGE_Y (w)
> > 				- WINDOW_MODE_LINE_HEIGHT (w));
> > 
> > It's an assertion violation, but the report doesn't even say what was
> > the text of the assertion message.  The above 2 macros could abort in
> > XFRAME, XWINDOW, or XBUFFER.
> 
> Yes, well there never is a recipe for this kind of thing

As I probably already said, they are probably related to your heavy
use of separate and minibuffer-less frames.  But this conclusion is
not instrumental to fixing those aborts, without a clear recipe to
reproduce a similar problem and/or without the ability to look around
when the abort does happen.  I urge you (again) to run Emacs from GDB
and leave the GDB session running long enough for us to ask you to
investigate after the abort.

> What's the point of adding such assertions and providing backtraces that are
> apparently useless?

The assertions are not specific to the aborts you experience.  They
are part of C macros, such as XWINDOW and XBUFFER, which extract C
data structures from a Lisp object.  These macros are used all over
the code.

> Anyway, multiple reports of crashes (by me and others) have not prevented Emacs
> 24.2 or 24.3 from being released.

In a release version, these assertions are not compiled into the
binary.

> FWIW, before Emacs 24 I rarely had an Emacs crash.

Probably because pretest and snapshot binaries before that were not
compiled with these assertions.

> Presumably such assertions are turned off when Emacs is released (?)

Yes.

> As you hint above, perhaps the assertions can be refined, so the backtraces
> produced become more informative.  I will continue to report them, unless you
> say it's not worth the trouble in general.

Please continue reporting them.  However, it will be much more useful
if you could let us investigate by using GDB.